local ADDON_NAME, namespace = ...
local L = namespace.L

--+ types:
--+---+-----------------------
--+ a + achievement
--+ t + toy
--+ m + transMog
--+ p + pet
--+ n + mouNt
--+ i + item
--+ h + headline
--+---+-------------------【ツ】

RecentDB = RecentDB or {}
--RecentFilered={}
local headingcount=0
local PlayerGUID = UnitGUID("player")

local LOOT_ITEM_CREATED_PATTERN
local LOOT_ITEM_CREATED_MULTIPLE_PATTERN 
local LOOT_ITEM_PATTERN
local LOOT_ITEM_MULTIPLE_PATTERN
local LOOT_ITEM_PUSHED_PATTERN
local LOOT_ITEM_PUSHED_MULTIPLE_PATTERN

function RecentNewDay()
	local max = table.getn(RecentDB)
	if max>0 and (sortDate(time()) ~= RecentDB[max].sd and RecentDB[max].type ~= 'h') then
		table.insert(RecentDB, {ts=RecentDB[max].ts , lnk='|cff9d9d9d|Hitem:4784::::::::60:::::|h[Lifeless Stone]|h|r' ,qnty= nil, sd=RecentDB[max].sd, loc=nil , iid=nil, type='h', addinfo=nil}) 
	end
end

function RecentCreateFilteredList()
	if RecentFiltered and RecentDB then				-- only update latest new item
		local max = table.getn(RecentDB)
		if max>=1 then
			if  (string.len(RecentDB[max].lnk)==0 and RecentDB[max].type=="m" and RecentDB[max].iid~=nil) then  --repair broken mox 
				local _, visualID, _, icon, _, _, link = C_TransmogCollection.GetAppearanceSourceInfo(RecentDB[max].iid)			
				RecentDB[max].lnk=link
			end
			local p = RecentDB[max]
			local _, _, _, _, _, itemClassID, itemSubClassID = GetItemInfoInstant(p.lnk)    
	
			if p.type ~= "i" or itemClassID== 2 or itemClassID== 4 or itemClassID== 9 then
				table.insert(RecentFiltered, {ts=p.ts , lnk=p.lnk ,qnty= p.qnty , sd=p.sd, loc=p.loc , iid=p.iid, type=p.type, addinfo=p.addinfo})
			end
		end
	else
	  RecentFiltered={}							-- initialize FilterList
	  local again=0
	  for v, p in pairs(RecentDB) do
			if  (string.len(p.lnk)==0 and p.type=="m" and p.iid~=nil) then		--repair broken mox 
				local _, visualID, _, icon, _, _, link = C_TransmogCollection.GetAppearanceSourceInfo(p.iid)			
				RecentDB[v].lnk=link
			end
			local _, _, _, _, _, itemClassID, itemSubClassID = GetItemInfoInstant(p.lnk)    
			--    local itemClass = itemClassID * 100 + itemSubClassID
			if p.type ~= "i" or itemClassID== 2 or itemClassID== 4 or itemClassID== 9 then
				table.insert(RecentFiltered, {ts=p.ts , lnk=p.lnk ,qnty= p.qnty , sd=p.sd, loc=p.loc , iid=p.iid, type=p.type, addinfo=p.addinfo}) 
				if p.type == 'h' and again== 1 then 
					table.remove(RecentFiltered,table.getn(RecentFiltered)-1)
				elseif p.type == 'h' then
					again=1
				else
					again=0
				end
			end
		end
	end
end

function GetFullDate(weekday, month, day, year)
	local weekdayName = CALENDAR_WEEKDAY_NAMES[weekday];
	local monthName = CALENDAR_FULLDATE_MONTH_NAMES[month];
	return weekdayName, monthName, day, year, month;   
end

function sameAsBefore(itemlink)
	local max = table.getn(RecentDB)

	if max>1 then
		if RecentDB[max].type == 'h' then max = max -1 end
		if itemlink==RecentDB[max].lnk then
			local m,d,y = string.match(date("%x",RecentDB[max].ts), '(%d+)/(%d+)/(%d+)')
			local hour = string.match(date("%H", RecentDB[max].ts), '(%d+)')
			local minutes = string.match(date("%M", RecentDB[max].ts), '(%d+)')
			local m1,d1,y1 = string.match(date("%x",time()), '(%d+)/(%d+)/(%d+)')
			local hour1 = string.match(date("%H", time()), '(%d+)')
			local minutes1 = string.match(date("%M", time()), '(%d+)')
			if m==m1 and d==d1 and y==y1 and (minutes==minutes1 or minutes + 1==minutes1) and hour==hour1 then
				return true
			else 
				return false
			end
		else
			return false
		end
	else
		return false
	end
end 

function localizedDate(...)
	local weekday=date("%w",...)
	local m,d,y = string.match(date("%x",...), '(%d+)/(%d+)/(%d+)')
	return format(FULLDATE, GetFullDate(tonumber(weekday)+1, tonumber(m), tonumber(d), 2000+tonumber(y)))
end

function formattedTime(...)
	local hour = tonumber(date("%H", ...))
	local minutes = tonumber(date("%M", ...))
	return (GameTime_GetFormattedTime(hour,minutes,true))
end

function sortDate(...)
	local m,d,y = string.match(date("%x",...), '(%d+)/(%d+)/(%d+)')
	return string.format('%s/%s/%s', y,m,d)
 end

function printtable()
    print('...................'.. table.getn(RecentDB))
    for v, p in pairs(RecentDB) do
       print(v, p.lnk, p.type, p.iid, p.sd )
    end
end

function openMount(link)
	if not InCombatLockdown() then
		local mountID = 0
		local _, _, _, linkType, linkID = strsplit(":|H", link)
		if linkType == "item" then
		mountID = C_MountJournal.GetMountFromItem(tonumber(linkID))
		elseif linkType == "spell" then
		mountID = C_MountJournal.GetMountFromSpell(tonumber(linkID))
		end
		if not CollectionsJournal then
			CollectionsJournal_LoadUI()
		end
		SetCollectionsJournalShown(true, COLLECTIONS_JOURNAL_TAB_INDEX_MOUNTS)
		MountJournal_SelectByMountID(mountID)
	end
end

function openPet(link)
   	if not InCombatLockdown() then
		local numPets, numOwned = C_PetJournal.GetNumPets()
		local out
		local _, _, _, linkType, linkID, _, _, _, _, _, battlePetID = strsplit(":|H",link)
		local a, b, c, creatureID, d, e, f, g, h, j,k, displayID, speciesIDo = C_PetJournal.GetPetInfoByItemID(tonumber(linkID))
		
		for i=1, numPets do
			local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, _, _, _, _, canBattle = C_PetJournal.GetPetInfoByIndex(i)

			if (speciesID == speciesIDo) then 
				out = petID 
				petIndex = i
				break;
			end
		end
		
	--	print(speciesID, speciesIDo, petIndex, out) -- petID, gsub(petLink, "\124", "\124\124"))
		if ( petIndex ) then 
			if not CollectionsJournal then
				CollectionsJournal_LoadUI()
			end
			SetCollectionsJournalShown(true, COLLECTIONS_JOURNAL_TAB_INDEX_PETS)
		--	print(speciesID, speciesIDo, petIndex, out) -- petID, gsub(petLink, "\124", "\124\124"))
			PetJournalPetList_UpdateScrollPos(PetJournal.listScroll, petIndex)
			PetJournal_ShowPetCardByID(out)
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF5555Recent:|rPet is still to learn!", 1.0, 0.8, 0.2);
		end
	end
end


function setNew(vID)
	local indexOffset = (WardrobeCollectionFrame.ItemsCollectionFrame.PagingFrame:GetCurrentPage() - 1) * WardrobeCollectionFrame.ItemsCollectionFrame.PAGE_SIZE
	for i = 1, WardrobeCollectionFrame.ItemsCollectionFrame.PAGE_SIZE do
	   local model = WardrobeCollectionFrame.ItemsCollectionFrame.Models[i]
	   local index = i + indexOffset;
	   local visualInfo = WardrobeCollectionFrame.ItemsCollectionFrame.filteredVisualsList[index]
	   if ( visualInfo ) then
		  if visualInfo.visualID==vID then 
			 model.NewString:Show()
			 model.NewGlow:Show()
			 break
		  end
	   end
	end
 end


function Recent_UpdateTooltip(self)
	if (self:GetParent().index) then
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		if (RDB[self:GetParent().index].type=="m") then
			local _, visualID, _, icon, _, itemLink, link = C_TransmogCollection.GetAppearanceSourceInfo(RDB[self:GetParent().index].iid)
			GameTooltip:SetHyperlink(itemLink)
		else
			GameTooltip:SetHyperlink(RDB[self:GetParent().index].lnk)
		end

		local ltext=""
		local rtext=""

		if (RDB[self:GetParent().index].type=="n" or RDB[self:GetParent().index].type=="m" or RDB[self:GetParent().index].type=="p") then
			rtext = L["<Rightclick> for preview"]
		end

		if (RDB[self:GetParent().index].type=="a" or RDB[self:GetParent().index].type=="t" or RDB[self:GetParent().index].type=="n" or RDB[self:GetParent().index].type=="m" or RDB[self:GetParent().index].type=="p") then
			ltext = L["<Leftclick> for collection"]
		end

		if (RDB[self:GetParent().index].type=="i") then
			itemID, itemType, itemSubType, itemEquipLoc, texture, itemClassID, itemSubClassID = GetItemInfoInstant(RDB[self:GetParent().index].lnk)
			if (itemEquipLoc == "INVTYPE_HEAD" or itemEquipLoc=="INVTYPE_SHOULDER" or itemEquipLoc=="INVTYPE_BODY" or itemEquipLoc=="INVTYPE_CHEST" or itemEquipLoc=="INVTYPE_ROBE" or itemEquipLoc=="INVTYPE_WAIST"  or itemEquipLoc=="INVTYPE_LEGS"  or itemEquipLoc=="INVTYPE_FEET"  or itemEquipLoc=="INVTYPE_WRIST"  or itemEquipLoc=="INVTYPE_HAND"  or itemEquipLoc=="INVTYPE_CLOAK"  or itemEquipLoc=="INVTYPE_WEAPON"  or itemEquipLoc=="INVTYPE_SHIELD"  or itemEquipLoc=="INVTYPE_2HWEAPON"  or itemEquipLoc=="INVTYPE_WEAPONMAINHAND"  or itemEquipLoc=="INVTYPE_WEAPONOFFHAND"  or itemEquipLoc=="INVTYPE_HOLDABLE" or itemEquipLoc=="INVTYPE_RANGED" or itemEquipLoc=="INVTYPE_THROWN" or itemEquipLoc=="INVTYPE_RANGEDRIGHT" or itemEquipLoc=="INVTYPE_TABARD") then
				rtext = L["<Rightclick> for preview"]
			end	
		end

		if (rtext ~= "" or ltext ~= "" ) then
			GameTooltip:AddLine(" ",1,1,1)
			GameTooltip:AddDoubleLine(ltext ,rtext,1,1,1,1,1,1)
			GameTooltip:AddLine(" ",1,1,1)
			GameTooltip:Show()
		end
	end
end
   
function RecentUpdateList()

	local scrollFrame = RecentListFrame.ListScrollFrame
	local offset, _ = HybridScrollFrame_GetOffset(scrollFrame)
	local buttons = scrollFrame.buttons
	headingcount=0
--	local playerLevel = UnitLevel("player")
	local prevdate=sortDate(time())
	local numDisplayedObjects = table.getn(RDB)

	for i=1, #buttons-1 do
		local itemName="x"
		local texture, itemName, itemClassID, itemSubClassID,itemRarity, itemLevel
		local button = buttons[i]
		local displayIndex = numDisplayedObjects - (i + offset)+1;

		if ( displayIndex > 0 ) then       
			local index = displayIndex
			local meta = nil
			button.factionIcon:SetShown(false)
			if index> 0 and (RDB[index].type == 'h') and index <= numDisplayedObjects then 

				button.name:SetFontObject("GameFontNormalLarge")
				button.name:SetJustifyH("CENTER")
				button.name:SetText(localizedDate(RDB[index].ts))
				button.level:SetText(nil)
				button.icon:SetAlpha(0)
				prevdate=RDB[index].sd 
				button.selected = false
				button.selectedTexture:Hide()
				button.background:SetVertexColor(0, 0, 0, 0)
				button:SetHighlightTexture(nil)
				button.iconBorder:Hide()
				button.index = nil
				button.DragButton:SetEnabled(false)
				button.DragButton.ActiveTexture:Hide()
				button.name:SetTextColor(1,1,1,1)
				button.new:SetShown(false)
				button.new:SetText("")
				button.newGlow:SetShown(false)
				button:Show()

			elseif index <= numDisplayedObjects and index>0 then

				if (RDB[index].type == "a" ) then			-- Achievement
					id, itemName, points, completed, month, day, year, description, flags, texture, rewardText, isGuild, wasEarnedByMe, earnedBy = GetAchievementInfo(RDB[index].iid)							
					itemClassID = nil
					itemSubClassID = nil
					itemRarity = 2
					button.name:SetTextColor(1,1,1,1)
					button.level:SetText("")
					if completed== false and RDB[index].addinfo then 
						itemName=RDB[index].addinfo 
						meta=true
					end

				elseif (RDB[index].type == "m") then									--mog
					local _, visualID, _, icon, _, itemLink, link = C_TransmogCollection.GetAppearanceSourceInfo(RDB[index].iid)
					itemName, _, _, _, _, _,_, _, _, _,	_, _, _, _, _,_, _ = GetItemInfo(itemLink)			
					texture=icon
					itemClassID = nil
					itemSubClassID = nil
					button.name:SetTextColor(1,0.5,1,1)
					button.level:SetText("")
					if (itemName==nil) then
						itemID, itemType, itemSubType, itemEquipLoc, texture, itemClassID, itemSubClassID = GetItemInfoInstant(RDB[index].lnk) 
						itemRarity = 1
						itemLevel = 0
						_ , itemName = RDB[index].lnk:match("|H(.*)|h%[(.*)%]|h")
					end

				elseif (RDB[index].type == "i" or RDB[index].type == "t" or RDB[index].type == "p" or RDB[index].type == "n") then			--Item
					itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
					itemSubType, itemStackCount, itemEquipLoc, texture,
					itemSellPrice, itemClassID, itemSubClassID, bindType, expacID,
					itemSetID, isCraftingReagent = GetItemInfo(RDB[index].lnk)

					if (itemRarity==nil) then
						itemID, itemType, itemSubType, itemEquipLoc, texture, itemClassID, itemSubClassID = GetItemInfoInstant(RDB[index].lnk) 
						itemRarity = 1
						itemLevel = 0
						_ , itemName = RDB[index].lnk:match("|H(.*)|h%[(.*)%]|h")
					else
						itemLevel, isPreview, baseILvl = GetDetailedItemLevelInfo(RDB[index].lnk)
					end

					button.name:SetTextColor(BAG_ITEM_QUALITY_COLORS[itemRarity].r,BAG_ITEM_QUALITY_COLORS[itemRarity].g,BAG_ITEM_QUALITY_COLORS[itemRarity].b,1)
					button.level:SetTextColor(BAG_ITEM_QUALITY_COLORS[itemRarity].r,BAG_ITEM_QUALITY_COLORS[itemRarity].g,BAG_ITEM_QUALITY_COLORS[itemRarity].b,1)
					button.level:SetText("[".. itemLevel .. "]")

				end
				button.factionIcon:SetVertexColor(1, 1, 1, 1) 

				if (RDB[index].type == "p") then
					button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\pet")
					button.factionIcon:SetShown(true)

				elseif (RDB[index].type == "n") then
					button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\mount")
					button.factionIcon:SetShown(true)

				elseif (RDB[index].type == "t" ) then
					button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\toy")
					button.factionIcon:SetShown(true)

				elseif (RDB[index].type == "a" ) then
					button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\ACHIEVEMENT")
					button.factionIcon:SetShown(true)
					if meta==true then 
						button.factionIcon:SetVertexColor(0.3, 0.3, 0.8, 1) 
					end

				elseif (RDB[index].type == "m" ) then
					button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\mog")
					button.factionIcon:SetShown(true)

				else
				button.factionIcon:SetTexture("")
					button.factionIcon:SetShown(false)
				end
				
				local count=""
				if RDB[index].qnty ~= nil then
					if tonumber(RDB[index].qnty) >= 2 then count= "|cFFAAAAAA x "..RDB[index].qnty.. "|r"  end
				end
				
				local nameText= itemName..count
				button.level:SetJustifyH("RIGHT")
				button.name:SetJustifyH("LEFT")
				button.name:SetText("   ".. nameText)
				button.icon:SetTexture(texture)
				button:SetHighlightTexture("Interface\\AddOns\\Recent\\media\\whitedot", "ADD") 
				button.index = index
				button.spellID = index

				button.active = active
				button:Show()
				
				if ( RecentListFrame.selectedSpellID == index ) then 
					button.selected = true;
					button.selectedTexture:Show()
					button.selectedTexture:SetTexture("Interface\\AddOns\\Recent\\media\\yellowdot", "ADD")	
					button.DragButton.ActiveTexture:Show()
				else
					button.selected = false
					button.selectedTexture:Hide()
					button.DragButton.ActiveTexture:Hide()
				end
				
				button:SetEnabled(true);
				button.background:SetVertexColor(1, 1, 1, 1)
				button.DragButton:SetEnabled(true)
				button.additionalText = nil
				button.icon:SetDesaturated(false)
				button.icon:SetAlpha(1.0)
				button.name:SetFontObject("GameFontNormal")

				if ( button.showingTooltip ) then
					MountJournalMountButton_UpdateTooltip(button)
				end
			end
		else
			button:Hide()
		end
	 end

	 local totalHeight = (table.getn(RDB)) * 46
	 HybridScrollFrame_Update(RecentListFrame.ListScrollFrame, totalHeight, RecentListFrame.ListScrollFrame:GetHeight())
end

function RecentSetSelection(number)
	if (number and table.getn(RDB)>0) then
		RecentListFrame.selectedSpellID=number
		if (RDB[number].loc) then 
			RecentListFrame.BottomLeftInset.SlotRequirementLabel:Show()
			RecentListFrame.BottomLeftInset.WhenLabel:Show()
			RecentListFrame.BottomLeftInset.WhereLabel:Show()
			RecentListFrame.BottomLeftInset.SlotLabel:Show()
			RecentListFrame.BottomLeftInset.WhatLabel:Show()
			RecentListFrame.BottomLeftInset.WhatText:Show()
			RecentListFrame.BottomLeftInset.SlotLabel:SetText(formattedTime(RDB[number].ts) .. L[" "] .. " - " .. localizedDate(RDB[number].ts))
			RecentListFrame.BottomLeftInset.SlotRequirementLabel:SetText(RDB[number].loc) 

			if (RDB[number].type=="i" or RDB[number].type=="t" or RDB[number].type=="n" or RDB[number].type=="p") then
				local itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
				itemSubType, itemStackCount, itemEquipLoc, texture,
				itemSellPrice, itemClassID, itemSubClassID, bindType, expacID,
				itemSetID, isCraftingReagent = GetItemInfo(RDB[number].lnk)			
				RecentListFrame.BottomLeftInset.WhatText:SetText(itemType .. " > " .. (string.len(itemEquipLoc)>0 and itemSubType .. " > ".. _G[itemEquipLoc] or itemSubType))  

			elseif (RDB[number].type=="m") then
				RecentListFrame.BottomLeftInset.WhatText:SetText(L["Transmogification"])
				
			elseif (RDB[number].type=="a") then
				RecentListFrame.BottomLeftInset.WhatText:SetText(L["Achievement"])
			end

		else
			RecentListFrame.BottomLeftInset.SlotRequirementLabel:Hide()
			RecentListFrame.BottomLeftInset.SlotLabel:Hide()
			RecentListFrame.BottomLeftInset.WhenLabel:Hide()
			RecentListFrame.BottomLeftInset.WhereLabel:Hide()
			RecentListFrame.BottomLeftInset.WhatLabel:Hide()
			RecentListFrame.BottomLeftInset.WhatText:Hide()
		end
		
		RecentListFrame.BottomLeftInset.WhenLabel:SetText(L[" When:"])
		RecentListFrame.BottomLeftInset.WhereLabel:SetText(L[" Where:"])
		RecentListFrame.BottomLeftInset.WhatLabel:SetText(L[" What:"])
		RecentUpdateList()
	end
end

function RecentListItem_OnClick(self, button)
	RecentSetSelection(self.index)
end

function RecentJunk_OnClick(self)
	local isChecked = self:GetChecked()
	if isChecked then
		RDB=RecentDB
	else
		RDB=RecentFiltered
	end
	RecentUpdateList()
end

function RecentListDragItem_OnClick(self, button)
	if button == "LeftButton" then
		if not CollectionsJournal then
			_G.CollectionsJournal_LoadUI()
		end
	
		if RDB[self:GetParent().index].type == "p" then
--			if CollectionsJournal:IsShown() and self:GetParent().index == RecentListFrame.selectedSpellID and _G.CollectionsJournal_GetTab(CollectionsJournal)==2 then
--				_G.HideUIPanel(CollectionsJournal)
--			else
				openPet(RDB[self:GetParent().index].lnk)
--			end
	
		elseif RDB[self:GetParent().index].type == "n" then
--			if CollectionsJournal:IsShown() and self:GetParent().index == RecentListFrame.selectedSpellID and _G.CollectionsJournal_GetTab(CollectionsJournal)==1 then
--				_G.HideUIPanel(CollectionsJournal)
--			else
				openMount(RDB[self:GetParent().index].lnk)
--			end
	
		elseif RDB[self:GetParent().index].type == "t" then
	
			if not InCombatLockdown() then
				if (RDB[self:GetParent().index].iid ~= nil)  then
--					if CollectionsJournal:IsShown() and self:GetParent().index == RecentListFrame.selectedSpellID and CollectionsJournal_GetTab(CollectionsJournal)==3 then
--						HideUIPanel(CollectionsJournal)
--					else
						SetCollectionsJournalShown(true, COLLECTIONS_JOURNAL_TAB_INDEX_TOYS)		
						local page = ToyBox_FindPageForToyID(RDB[self:GetParent().index].iid)
						if page then
							ToyBox.PagingFrame:SetCurrentPage(page)
						end
--					end
				end
			end
			
		elseif RDB[self:GetParent().index].type == "m" then
	
			if not InCombatLockdown() then
--				if CollectionsJournal:IsShown() and self:GetParent().index == RecentListFrame.selectedSpellID and CollectionsJournal_GetTab(CollectionsJournal)==5 then
--					HideUIPanel(CollectionsJournal)
--				else
		
					local categoryID, visualID = C_TransmogCollection.GetAppearanceSourceInfo(RDB[self:GetParent().index].iid)
					local _, color, _, linkType, linkID = strsplit(":|H", RDB[self:GetParent().index].lnk)
					local mylink=linkType .. ":" .. tostring(linkID)                
					WardrobeCollectionFrame_OpenTransmogLink(mylink, nil)
					WardrobeCollectionFrame.ItemsCollectionFrame:RefreshVisualsList()
	
					WardrobeCollectionFrame.ItemsCollectionFrame:SelectVisual(visualID)
					WardrobeCollectionFrame.ItemsCollectionFrame:SetChosenVisualSource(visualID, RDB[self:GetParent().index].iid)
	
					C_Timer.After(0.25, function() setNew(visualID) end)  
--				end
			end
	
		elseif RDB[self:GetParent().index].type == "a" then
	
			if not InCombatLockdown() then
				if not AchievementFrame then
					AchievementFrame_LoadUI()
				end
	
--				if AchievementFrame:IsShown() and self:GetParent().index == RecentListFrame.selectedSpellID then
--					HideUIPanel(AchievementFrame)
--				else
					ShowUIPanel(AchievementFrame)
					AchievementFrame_SelectAchievement(RDB[self:GetParent().index].iid)
--				end
			end
		end
	
	elseif button == "RightButton" then
		if not InCombatLockdown() then
--			if DressUpFrame:IsShown() and self:GetParent().index == RecentListFrame.selectedSpellID then
--				HideUIPanel(DressUpFrame)
--			else	
				if RDB[self:GetParent().index].type == "m" then
						local _, color, _, linkType, linkID = strsplit(":|H", RDB[self:GetParent().index].lnk);
						categoryID, visualID, canEnchant, icon, _, itemLink, transmogLink, _ = C_TransmogCollection.GetAppearanceSourceInfo(linkID)
						DressUpItemLink(itemLink)
	
				elseif RDB[self:GetParent().index].type == "i" or RDB[self:GetParent().index].type == "p" or RDB[self:GetParent().index].type == "n" then
						DressUpBattlePetLink(RDB[self:GetParent().index].lnk)
						DressUpMountLink(RDB[self:GetParent().index].lnk)
						DressUpItemLink(RDB[self:GetParent().index].lnk)	
				end
--			end
		end
	end
	
	RecentSetSelection(self:GetParent().index)
end

function Recent_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED")
end

function Recent_OnShow(self)
	PlaySound(SOUNDKIT.IG_CHARACTER_INFO_OPEN);
	if (RecentListFrame.selectedSpellID == 0 or RecentListFrame.selectedSpellID == nil) then 
		if RDB then
			RecentSetSelection(table.getn(RDB)) 
		end
	end
end
 
function Recent_OnEvent(self, event, ...)
	local message, _, _, _, _, _, _, _, _, _, _, guid = ...

	if event == "ADDON_LOADED" and ... == "Recent" then 
            
		self:UnregisterEvent("ADDON_LOADED")
		self:RegisterEvent("CHAT_MSG_LOOT")
		self:RegisterEvent("ACHIEVEMENT_EARNED")
		self:RegisterEvent("CRITERIA_EARNED")
		self:RegisterEvent("LOOT_ITEM_ROLL_WON")
		self:RegisterEvent("TRANSMOG_COLLECTION_SOURCE_ADDED")
		self:RegisterEvent("TRANSMOG_COLLECTION_SOURCE_REMOVED")
		self:RegisterEvent("GET_ITEM_INFO_RECEIVED")
		self.ListScrollFrame.update = RecentUpdateList;
		
		LOOT_ITEM_BONUS_ROLL_MULTIPLE_PATTERN =LOOT_ITEM_BONUS_ROLL_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
		LOOT_ITEM_BONUS_ROLL_PATTERN = LOOT_ITEM_BONUS_ROLL_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
		LOOT_ITEM_CREATED_PATTERN = LOOT_ITEM_CREATED_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
	    LOOT_ITEM_CREATED_MULTIPLE_PATTERN = LOOT_ITEM_CREATED_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
	    LOOT_ITEM_PATTERN = LOOT_ITEM_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
	    LOOT_ITEM_MULTIPLE_PATTERN = LOOT_ITEM_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
	    LOOT_ITEM_PUSHED_PATTERN = LOOT_ITEM_PUSHED_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
	    LOOT_ITEM_PUSHED_MULTIPLE_PATTERN = LOOT_ITEM_PUSHED_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
		
		local needscorr=false		
	    local temp=""
	    local ctr=0
	    local threshold=7                                    --   DAYS 2 KEEP
	
	    for v, p in pairs(RecentDB) do
	       if p.sd ~= temp then
	          temp=p.sd
	          ctr=ctr+1
	       end   
	    end   
	
	    temp=""
	    while ctr>threshold do
	       
	       if temp == "" then temp=RecentDB[1].sd end 
	       if temp == RecentDB[1].sd then
				table.remove(RecentDB,1)
				needscorr=true
	       else     
	          ctr=ctr-1
	          temp=""
	       end
		end

		getglobal(RecentListFrame.RecentJunkButton:GetName() .. "Text"):SetText(L["show me everything"])
		RecentNewDay()
		RecentCreateFilteredList()
		RDB=RecentFiltered
		HybridScrollFrame_CreateButtons(self.ListScrollFrame, "RecentListButtonTemplate", 46, 0)   
		RecentUpdateList()

	elseif event == "CHAT_MSG_LOOT" and guid == PlayerGUID then 

		self:UnregisterEvent("GET_ITEM_INFO_RECEIVED")
		local link, quantity = message:match(LOOT_ITEM_MULTIPLE_PATTERN)
		if not link then
			link, quantity = message:match(LOOT_ITEM_PUSHED_MULTIPLE_PATTERN)
			if not link then
				link, quantity = message:match(LOOT_ITEM_CREATED_MULTIPLE_PATTERN)
				if not link then
					link, quantity = message:match(LOOT_ITEM_BONUS_ROLL_MULTIPLE_PATTERN)
					if not link then
						quantity, link = 1, message:match(LOOT_ITEM_PATTERN)
						if not link then
							quantity, link = 1, message:match(LOOT_ITEM_PUSHED_PATTERN)
							if not link then
								quantity, link = 1, message:match(LOOT_ITEM_CREATED_PATTERN)
								if not link then
									quantity, link = 1, message:match(LOOT_ITEM_BONUS_ROLL_PATTERN)
								end
							end
						end
					end		
				end
			end
		end
		if (link~= nil) then
			local itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
				itemSubType, itemStackCount, itemEquipLoc, texture,
				itemSellPrice, itemClassID, itemSubClassID, bindType, expacID,
				itemSetID, isCraftingReagent = GetItemInfo(link)

			
			local a, color, b, linkType, linkID = strsplit(":|H", link)				
			local itemID, toyName, icon, isFavorite, hasFanfare = C_ToyBox.GetToyInfo(linkID)
			local itype= "i"

			if (itemID ~= nil)  then itype="t" 
			elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_COMPANION_PET) then itype="p"
			elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_MOUNT) then itype="n"
			end

			local timestamp = time()

			if sameAsBefore(link) then
				local max = table.getn(RecentDB)
				local cnt
				if RecentDB[max].qnty == nil then cnt =1 else cnt=RecentDB[max].qnty end
				RecentDB[max].qnty = cnt + quantity
				RecentUpdateList()    
			else
				if itemRarity > 2 or itype=="p" or itype=="n" or itype=="t" then 
					RecentNewDay()
					table.insert(RecentDB, {ts=timestamp , lnk=link ,qnty= quantity , sd=sortDate(time()), loc= (string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=itemID, type=itype, addinfo=nil })  
					RecentCreateFilteredList()
					RecentUpdateList()  
				end   
			end
		end
	elseif event == "ACHIEVEMENT_EARNED" then

		local achID, already = ...
		local id, name, points, completed, month, day, year, description, flags, icon, rewardText, isGuild, wasEarnedByMe, earnedBy = GetAchievementInfo(achID)

		local link = GetAchievementLink(achID)
		RecentNewDay()
		local timestamp = time()
		table.insert(RecentDB, {ts=timestamp , lnk=link ,qnty=nil , sd=sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=achID, type="a", addinfo=nil})  
		RecentCreateFilteredList()
		RecentUpdateList()

	elseif event == "CRITERIA_EARNED" then

		local achID, criteriaString  = ...
		local id, name, points, completed, month, day, year, description, flags, icon, rewardText, isGuild, wasEarnedByMe, earnedBy = GetAchievementInfo(achID)

		local link = GetAchievementLink(achID)
		RecentNewDay()
		local timestamp = time()
		table.insert(RecentDB, {ts=timestamp , lnk=link ,qnty=nil , sd=sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=achID, type="a", addinfo=criteriaString})  
		RecentCreateFilteredList()
		RecentUpdateList()   

	elseif event == "LOOT_ITEM_ROLL_WON" then

		local link, quantity, rollType, roll, isUpgraded = ...
		local itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
	        itemSubType, itemStackCount, itemEquipLoc, texture,
	        itemSellPrice, itemClassID, itemSubClassID, bindType, expacID,
	        itemSetID, isCraftingReagent = GetItemInfo(link)

		local a, color, b, linkType, linkID = strsplit(":|H", RecentDB[self:GetParent().index].lnk);				
		local itemID, toyName, icon, isFavorite, hasFanfare = C_ToyBox.GetToyInfo(linkID)

		local itype= "i"
		if (itemID ~= nil)  then itype="t" 
		elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_COMPANION_PET) then itype="p"
		elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_MOUNT) then itype="n"
		end

	    local timestamp = time()
	    
	    if itemRarity > 2 or itype=="p" or itype=="n" or itype=="t" then		
			RecentNewDay()
			table.insert(RecentDB, {ts=timestamp , lnk=link ,qnty= quantity , sd=sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) ,  iid=itemID, type=itype, addinfo=nil})  
			RecentCreateFilteredList()
			RecentUpdateList() 
		end   

	elseif event == "TRANSMOG_COLLECTION_SOURCE_ADDED" then	
		sourceID, isAdded, attempt = ...
		if (sourceID~= nil) then
			local _, visualID, _, icon, _, _, link = C_TransmogCollection.GetAppearanceSourceInfo(sourceID)
			local timestamp = time()
			if string.len(link)>0 then
				RecentNewDay()
				table.insert(RecentDB, {ts=timestamp , lnk=link ,qnty= nil , sd=sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=sourceID, type="m", addinfo=nil}) 
				RecentCreateFilteredList()
				RecentUpdateList()
			end
		end

	elseif event == "GET_ITEM_INFO_RECEIVED" then

		if RecentListFrame:IsShown() then 
--			RecentCreateFilteredList()
			RecentUpdateList()

		end
	end
end

tinsert(UISpecialFrames, "RecentListFrame");
UIPanelWindows["RecentListFrame"] = nil;

SLASH_RECENT1 = "/recent"
SLASH_RECENT2 = "/rct"
SLASH_RECENT3 = "/rcnt"

SlashCmdList["RECENT"] = function(msg, editbox)
	if msg and (msg == 'clear') then
		RecentDB = {}
		RDB={}
    elseif msg and (msg == 'list') then 
    	printtable()
    else
    	RecentListFrame:Show()
    end
end
